%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Course: ECE438
%name: Yang Zhu
%last updated Date: 2011/12/4
%Description:calculate edge direction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y = calc_edge_direction(x)
    [row,col]=size(x);
    col = round(col/3);
    x = x(1:row,1:col);
    y(:,1)=abs(x(:,1)-x(:,1));
    y(:,col)=abs(x(:,col)-x(:,col));
    y(1,:)=abs(x(1,:)-x(1,:));
    y(row,:)=abs(x(row,:)-x(row,:));

    for m=2:row-1
        for n=2:col-1
            temp(1) = x(m,n)-x(m-1,n);
            temp(2) = x(m,n)-x(m,n-1);
            temp(3) = x(m,n)-x(m+1,n);
            temp(4) = x(m,n)-x(m,n+1);
            temp(5) = (x(m,n)-x(m-1,n-1))/sqrt(2);
            temp(6) = (x(m,n)-x(m-1,n+1))/sqrt(2);
            temp(7) = (x(m,n)-x(m+1,n+1))/sqrt(2);
            temp(8) = (x(m,n)-x(m+1,n-1))/sqrt(2);
            temp1(1) = abs(temp(1));
            temp1(2) = abs(temp(2));
            temp1(3) = abs(temp(3));
            temp1(4) = abs(temp(4));
            temp1(5) = abs(temp(5));
            temp1(6) = abs(temp(6));
            temp1(7) = abs(temp(7));
            temp1(8) = abs(temp(8));
            for i = 1:8
                if temp1(i) == max(temp1)
                    if temp(i)> 0
                        y(m,n) = i-1;
                    elseif temp(i)<0
                        y(m,n) = i+7;
                    else
                        y(m,n) = 16;
                    end
                end
            end
            
        end
    end
    y = reshape(y,1,row*col);
    
end